﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Collections;

public partial class Tickets_326622_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Page.IsPostBack)
        {
            MyData.BusinessDataStorage.Create(27, 7);
        }
    }

    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = MyData.BusinessDataStorage.GetData();
    }

    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridEditFormItem && e.Item.IsInEditMode)
        {
            GridEditFormItem editForm = (GridEditFormItem)e.Item;
            RadComboBox CategoryCombo = (RadComboBox)editForm.FindControl("CategoryCombo");
            
            CategoryCombo.DataSource = MyData.BusinessDataStorage.GetCategories();
            CategoryCombo.DataBind();

            CategoryCombo.SelectedValue = editForm.GetDataKeyValue("CategoryID").ToString();
        }
    }

    protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
    {
        GridEditFormItem editForm = (GridEditFormItem)e.Item;
        Hashtable values = new Hashtable();
        editForm.ExtractValues(values);

        int itemId = (int)editForm.GetDataKeyValue("ID");
        MyData.BusinessObject myObj =  MyData.BusinessDataStorage.Find(itemId);

        if (myObj != null)
        {
            myObj.Name = values["Name"].ToString();
            myObj.CategoryID = Convert.ToInt32(((RadComboBox)editForm.FindControl("CategoryCombo")).SelectedValue);
            myObj.Date = (DateTime)values["Date"];
            myObj.Quantity = Convert.ToInt32(values["Quantity"]);
            myObj.Price = (double)values["Price"];
            myObj.Available = (bool)values["Available"];
        }

        RadGrid1.Rebind();
    }
}